using System;
using Gtk;
using lliurex;
using System.IO;
using System.Configuration; //save data
using System.Globalization; // culture
using System.Collections.Generic; //list


namespace lliurex
{
	namespace mirror
	{

		public partial class MainWindow : Gtk.Window
		{
			System.Diagnostics.Process ddproc;
			static MainWindow instancia;
			String sharedbuffer;
			string mirrorPath = "/net/mirror/llx1109/";
			bool stopFlag;
			public long mirrorSize = 0;
			static string templatesPath = "/usr/share/lliurex-mirror/templates/";
			static string lastPath = "/usr/share/lliurex-mirror/last/";
			static string templateCustomServer = templatesPath + "updates.from.custom.server";
			static string mirrorsToManage ="/net/mirror/";
			static string mirrorScritpNonInteractive = "/usr/sbin/lliurex-mirror-non-gtk";
			static string SCRIPT_NON_INTERACTIVE_UPDATE =" update ";
			static string SCRIPT_NON_INTERACTIVE_UPGRADE =" upgrade";

			//scheduler INIT
			const int MAX_CHKS = 168;
			const int Page1Width = 540;
			const int Page1Heigth = 540;			
			const int Page2Width = 780;
			const int Page2Heigth = 313;			

			messagebox ms = new messagebox();
      
			static string applicationName = Environment.GetCommandLineArgs()[0];
      		static string exePath = System.IO.Path.Combine(Environment.CommandLine,applicationName);
     		System.Configuration.Configuration configFile = ConfigurationManager.OpenExeConfiguration(exePath);
		
        	Gtk.Table taula;
			Gtk.Button[] botonsDia= new Gtk.Button[7];
			Gtk.Button[] botonsHora= new Gtk.Button[24];
			Gtk.Label[] lblBotoHora= new Gtk.Label[24];
			Gtk.CheckButton[] chkProg = new Gtk.CheckButton[MAX_CHKS];
			List<Gtk.CheckButton>[] listDia = new List<Gtk.CheckButton>[7];
			List<Gtk.CheckButton>[] listHora = new List<Gtk.CheckButton>[24];	
			CultureInfo language= (CultureInfo)CultureInfo.CurrentCulture.Clone();
			//scheduler END

			
			/// <summary>
			/// Returns mirrors available to be managed by lliurex-mirror
			/// </summary>
			/// <returns>
			/// A <see cref="System.String[]"/> that contains all mirrors that are availabe under 
			/// /usr/share/lliurex-mirror/mirrors.d/
			/// </returns>
			public string[] getAvailableMirrors()
			{
				string[] mirrors_available=null;
				if(System.IO.Directory.Exists(mirrorsToManage))
				{
					mirrors_available= System.IO.Directory.GetDirectories(mirrorsToManage);
				}
				return mirrors_available;
			}
			
			
	
			
			
			public MainWindow () : base(Gtk.WindowType.Toplevel)
			{
				sharedbuffer = "";
				instancia = this;
				Mono.Unix.Catalog.Init("lliurex-mirror","/usr/share/locale");
				Build ();
				//scheduler INIT
				montaTabla();

				
				this.Resize(Page1Width,Page1Heigth);
			
				//scheduler END				
				
				mirrorSize = getMirrorSize();
					
				rbUpdateFromInternet.Active = true;
				
				if (System.IO.File.Exists ("/usr/share/lliurex-mirror/last/updates.from.custom.server")) {
					Console.WriteLine ("Loading custom server conf...");
					StreamReader sr = new StreamReader ("/usr/share/lliurex-mirror/last/updates.from.custom.server");
					String line;
					while (!sr.EndOfStream) {
						line = sr.ReadLine ();
						line = line.Replace (" ", "");
						
						if (line.StartsWith ("Method:")) {
							int index = line.IndexOf (':');
							line = line.Substring (index + 1);
							Console.WriteLine ("Found: ->" + line);
							entryUpdateFromServer.Text = line;
							rbUpdateFromServer.Active = true;
						}
						
						
						
					}
					sr.Close ();
				} else
					Console.WriteLine ("No current config found");
				
				if (System.IO.File.Exists ("/usr/share/lliurex-mirror/last/updates.from.file")) {
					
					StreamReader sr = new StreamReader ("/usr/share/lliurex-mirror/last/updates.from.file");
					String line;
					while (!sr.EndOfStream) {
						line = sr.ReadLine ();
						//line = line.Replace(" ","");
						
						if (line.StartsWith ("Method:")) {
							int index = line.IndexOf (':');
							line = line.Substring (index + 1);
							line = line.Trim ();
							line = line.Replace ("file://", "");
							Console.WriteLine ("Found: ->" + line);
							filechooserUpdateFromDirectory.SetFilename (line);
							rbUpdateFromDirectory.Active = true;
							
						}
						
						
					}
					
					sr.Close ();
					
					
				} else
					Console.WriteLine ("No current config found");
				
			}
			
			/// <summary>
			/// Returns the mirror size
			/// </summary>
			/// <returns>
			/// A <see cref="System.Int64"/> 
			/// </returns>
			public long getMirrorSize()
			{
				long result=0;
				string sizeOfNetMirror=" ";
				string stderror="";
				lliurex.utils.Commands.run("du","-s /net/mirror",out sizeOfNetMirror,out stderror);
				sizeOfNetMirror = sizeOfNetMirror.Replace(" ","");
				int index = sizeOfNetMirror.IndexOf("/");
				sizeOfNetMirror = sizeOfNetMirror.Substring(0,index-1);
				Console.WriteLine("SIZE OF NET-MIRROR (SYSTEM) : {0}",sizeOfNetMirror);
				return result;
			}

			protected void OnDeleteEvent (object sender, DeleteEventArgs a)
			{
				Application.Quit ();
				a.RetVal = true;
			}
			protected virtual void OnButtonExitClicked (object sender, System.EventArgs e)
			{
				Application.Quit ();
			}

			protected virtual void OnButtonRefreshClicked (object sender, System.EventArgs e)
			{
				//
				disableButtons ();
				GLib.Timeout.Add (100, new GLib.TimeoutHandler (updateEvilProgressBar));
				System.Diagnostics.Process proc = new System.Diagnostics.Process ();
				proc.StartInfo.FileName = "/usr/bin/reprepro";
				proc.StartInfo.Arguments = " -b " + mirrorPath + " checkpool ";
				ddproc = proc;
				textviewMessages.Buffer.Text += Mono.Unix.Catalog.GetString ("Starting reprepro checkpool, please wait\n");
				proc.Start ();
			}
			/*lliurex.utils.Commands.run("gedit");*/

			protected virtual void disableButtons ()
			{
				buttonDeleteAndCreate.Sensitive = false;
				buttonUpdate.Sensitive = false;
			}


			/// <summary>Habilita botones</summary>
			protected virtual void enableButtons ()
			{
				
				buttonDeleteAndCreate.Sensitive = true;
				buttonUpdate.Sensitive = true;
			}



			protected bool updateEvilProgressBar ()
			{
				bool ret = true;
				progressbar3.Pulse ();
				if (ddproc.HasExited) {
					Console.WriteLine (" Codigo Stado " + ddproc.ExitCode.ToString ());
					progressbar3.Fraction = 0.0;
					/*label_message.Text=*/					
					textviewMessages.Buffer.Text += Mono.Unix.Catalog.GetString ("Finished\n");
					enableButtons ();
					ret = false;
				}
				return ret;
			}

			protected bool progressEvilProgressBar ()
			{
				bool ret = true;
				System.Text.RegularExpressions.Regex re = new System.Text.RegularExpressions.Regex ("Got\\s(?<percent>[0-9]+)\\%\\.*");
				
				if (ddproc == null)
					return ret;
				ddproc.Refresh ();
				
				if (sharedbuffer != "" && sharedbuffer != null) {
					System.Text.RegularExpressions.Match ma = re.Match (sharedbuffer);
					if (ma.Success) {
						int res;
						int.TryParse (ma.Groups["percent"].Value, out res);
						progressbar3.Fraction = (double)res / 100.0;
						progressbar3.Text = ma.Groups["percent"].Value + "%";
					} else {
						textviewMessages.Buffer.Text += sharedbuffer + "\n";
					}
					sharedbuffer = "";
					TextIter ti = textviewMessages.Buffer.GetIterAtLine (textviewMessages.Buffer.LineCount - 1);
					textviewMessages.ScrollToIter (ti, 0.0, false, 0.0, 0.0);
				}
				
				if (ddproc.HasExited) {
					if (ddproc.ExitCode == 0) {
						progressbar3.Fraction = 1.0;
						textviewMessages.Buffer.Text += Mono.Unix.Catalog.GetString ("Finished\n");
						progressbar3.Text = Mono.Unix.Catalog.GetString ("Finished\n");
					} else {
						progressbar3.Fraction = 0.0;
						if (stopFlag) {
							textviewMessages.Buffer.Text += Mono.Unix.Catalog.GetString ("Stopped\n");
							progressbar3.Text = Mono.Unix.Catalog.GetString ("Stopped\n");
						} else {
							textviewMessages.Buffer.Text += Mono.Unix.Catalog.GetString ("Failed\n");
							progressbar3.Text = Mono.Unix.Catalog.GetString ("Failed\n");
						}
					}
					enableButtons ();
					ret = false;
				}
				return ret;
			}

			public void dataReceiver (object o, System.Diagnostics.DataReceivedEventArgs e)
			{
				
				System.Console.WriteLine ("Salida: " + e.Data + "\n");
			}

			public void errorReceiver (object o, System.Diagnostics.DataReceivedEventArgs e)
			{
				Gdk.Threads.Enter ();
				sharedbuffer = e.Data;
				Gdk.Threads.Leave ();
				System.Console.WriteLine ("Error: " + e.Data);
			}

			protected virtual void OnButtonUpdateClicked (object sender, System.EventArgs e)
			{
				SetUpdateConfiguration();
				ReplenishMirror ();
			}

			protected void getPool ()
			{
				disableButtons ();
				stopFlag = false;
				progressbar3.Fraction = 0.0;
				progressbar3.Text = Mono.Unix.Catalog.GetString ("Starting\n");
				GLib.Timeout.Add (100, new GLib.TimeoutHandler (progressEvilProgressBar));
				System.Diagnostics.Process proc = new System.Diagnostics.Process ();
				proc.StartInfo.FileName = "reprepro";
				proc.StartInfo.Arguments = "--show-percent -V --noskipold -b " + mirrorPath + " update";
				proc.StartInfo.UseShellExecute = false;
				proc.StartInfo.RedirectStandardOutput = true;
				proc.StartInfo.RedirectStandardError = true;
				proc.StartInfo.WorkingDirectory = "/usr/bin/";
				proc.OutputDataReceived += new System.Diagnostics.DataReceivedEventHandler (dataReceiver);
				proc.ErrorDataReceived += new System.Diagnostics.DataReceivedEventHandler (errorReceiver);
				ddproc = proc;
				textviewMessages.Buffer.Text += Mono.Unix.Catalog.GetString ("Starting reprepro update pool, please wait\n");
				proc.Start ();
				ddproc.BeginOutputReadLine ();
				ddproc.BeginErrorReadLine ();
			}

			protected virtual void OnButtonStopClicked (object sender, System.EventArgs e)
			{
				if (ddproc != null) {
					stopFlag = true;
					ddproc.Kill ();
					
					//TODO Arreglar reprepro clean up
					if (System.IO.File.Exists (mirrorPath + "db/lockfile")) {
						System.IO.File.Delete (mirrorPath + "db/lockfile");
					}
				}
			}

			public void SetUpdateConfiguration ()
			{
				if (rbUpdateFromServer.Active) {
					try {
						System.Uri uri = new System.Uri (entryUpdateFromServer.Text);
						Console.Error.WriteLine("DEBUG: "+uri.AbsoluteUri);
					} catch (System.UriFormatException ex) {
						Console.Error.WriteLine ("Invalid uri" + ex.ToString());
						return;
					}
					
					StreamReader sr = new StreamReader ("/usr/share/lliurex-mirror/templates/updates.from.custom.server");
					StreamWriter wr = new StreamWriter ("/usr/share/lliurex-mirror/last/updates.from.custom.server");
					String line;
					while (!sr.EndOfStream) {
						line = sr.ReadLine ();
						line = line.Replace ("_@_CUSTOM_SERVER_URL_@_", entryUpdateFromServer.Text);
						wr.WriteLine (line);
					}
					
					sr.Close ();
					wr.Close ();
					// Clean other files
					if (System.IO.File.Exists("/usr/share/lliurex-mirror/last/updates.from.file")){
						System.IO.File.Delete("/usr/share/lliurex-mirror/last/updates.from.file");
					}
					
					PrepareUpdateFromCustomServer ();
					//ToDo commands
				}else if (rbUpdateFromArxiu.Active){
					Console.Error.WriteLine("DEBUG: arxiu.lliurex.net is selected");
				
					StreamReader sr = new StreamReader ("/usr/share/lliurex-mirror/templates/updates.from.custom.server");
					StreamWriter wr = new StreamWriter ("/usr/share/lliurex-mirror/last/updates.from.custom.server");
					String line;
					while (!sr.EndOfStream) {
						line = sr.ReadLine ();
						line = line.Replace ("_@_CUSTOM_SERVER_URL_@_","http://arxiu.lliurex.net/marty");
						wr.WriteLine (line);
					}
					
					sr.Close ();
					wr.Close ();
					// Clean other files
					if (System.IO.File.Exists("/usr/share/lliurex-mirror/last/updates.from.file")){
						System.IO.File.Delete("/usr/share/lliurex-mirror/last/updates.from.file");
					}
					
					
					PrepareUpdateFromCustomServer ();
					
					
				} else if (rbUpdateFromDirectory.Active) {
					Console.WriteLine ("file://" + filechooserUpdateFromDirectory.Filename);
					StreamReader sr = new StreamReader ("/usr/share/lliurex-mirror/templates/updates.from.file");
					StreamWriter wr = new StreamWriter ("/usr/share/lliurex-mirror/last/updates.from.file");
					String line;
					
					while (!sr.EndOfStream) {
						line = sr.ReadLine ();
						//_@_PATH_TO_MIRROR_@_
						line = line.Replace ("_@_PATH_TO_MIRROR_@_", filechooserUpdateFromDirectory.Filename);
						wr.WriteLine (line);
					}
					
					sr.Close ();
					wr.Close ();
					// Clean other files
					if (System.IO.File.Exists("/usr/share/lliurex-mirror/last/updates.from.custom.server")){
						System.IO.File.Delete("/usr/share/lliurex-mirror/last/updates.from.custom.server");
					}
					
					PrepareUpdateFromFile ();
					//ToDo commands
				} else {
					PrepareUpdateFromLliurexNet ();
				}
			}

			protected virtual void OnButtonDeleteAndCreateClicked (object sender, System.EventArgs e)
			{
				
				// First Empty the Warrens
				ResetMirror ();
				
				// Check the correct source
				SetUpdateConfiguration ();
				
				//Final Operations:
				ReplenishMirror ();
			}

			public void PrepareUpdateFromLliurexNet ()
			{
				PrepareInitialFilesOnNetMirror ();
				lliurex.utils.Commands.run("wget", "-O /tmp/Packages.mirror http://lliurex.net/marty/dists/llx1109/restricted/binary-i386/Packages.gz");
				System.IO.File.Copy (templatesPath + "distributions", mirrorPath + "conf/distributions", true);
				System.IO.File.Copy (templatesPath + "updates.from.lliurex.net", mirrorPath + "conf/updates", true);
				
			}

			public void PrepareUpdateFromCustomServer ()
			{
				PrepareInitialFilesOnNetMirror ();
				
				System.IO.File.Copy (templatesPath + "distributions", mirrorPath + "conf/distributions", true);
				System.IO.File.Copy (lastPath + "updates.from.custom.server", mirrorPath + "conf/updates", true);
				
			}

			public void PrepareUpdateFromFile ()
			{
				PrepareInitialFilesOnNetMirror ();
				
				System.IO.File.Copy (templatesPath + "distributions", mirrorPath + "conf/distributions", true);
				System.IO.File.Copy (lastPath + "updates.from.file", mirrorPath + "conf/updates", true);
				
			}

			public void PrepareInitialFilesOnNetMirror ()
			{
				if (!System.IO.Directory.Exists (mirrorPath + "conf")) {
					System.IO.Directory.CreateDirectory (mirrorPath + "conf");
				}
			}

			public static MainWindow getInstance ()
			{
				return instancia;
			}

			public void ResetMirror ()
			{
				if (System.IO.Directory.Exists (mirrorPath + "db")) {
					System.IO.Directory.Delete (mirrorPath + "db", true);
				}
				if (System.IO.Directory.Exists (mirrorPath + "lists")) {
					System.IO.Directory.Delete (mirrorPath + "lists", true);
				}
				if (System.IO.Directory.Exists (mirrorPath + "pool")) {
					System.IO.Directory.Delete (mirrorPath + "pool", true);
				}
				if (System.IO.Directory.Exists (mirrorPath + "dists")) {
					System.IO.Directory.Delete (mirrorPath + "dists", true);
				}
				
			}

			public void ReplenishMirror ()
			{
				getPool ();
			}

			protected virtual void OnRbUpdateFromServerToggled (object sender, System.EventArgs e)
			{
				Console.WriteLine ("Load Method");
				if (System.IO.File.Exists (templateCustomServer)) {
					Console.WriteLine ("Load Method");
					Console.WriteLine (loadMethodFromFile (templateCustomServer));
				}
				
			}

			protected virtual string loadMethodFromFile (string path)
			{
				string method = "";
				System.Text.RegularExpressions.Regex re = new System.Text.RegularExpressions.Regex ("Method:\\s(?<method>)\\.*");
				using (StreamReader r = new StreamReader (path)) {
					string line;
					while ((line = r.ReadLine ()) != null) {
						System.Text.RegularExpressions.Match m = re.Match (line);
						if (m.Success) {
							method = m.Groups[1].Value;
						}
					}
				}
				return method;
			}

			protected virtual void OnRbUpdateFromServerClicked (object sender, System.EventArgs e)
			{
			}

			protected virtual void OnButtonSaveLocalMirrorClicked (object sender, System.EventArgs e)
			{
				
				Gtk.FileChooserDialog fdialog = new Gtk.FileChooserDialog (Mono.Unix.Catalog.GetString("Mirror location"), null, Gtk.FileChooserAction.SelectFolder);
				fdialog.AddButton (Mono.Unix.Catalog.GetString("Cancel"), Gtk.ResponseType.Cancel);
				fdialog.AddButton (Mono.Unix.Catalog.GetString("OK"), Gtk.ResponseType.Ok);
				Gtk.ResponseType result = (Gtk.ResponseType)fdialog.Run ();
				if (result == Gtk.ResponseType.Cancel || result == Gtk.ResponseType.DeleteEvent) {
					fdialog.Destroy ();
				} else {		
					
						string path = fdialog.Filename;
						
						System.IO.DriveInfo[] drive_list = System.IO.DriveInfo.GetDrives ();
						System.IO.DriveInfo drive_target = new System.IO.DriveInfo ("/");
						
						foreach (System.IO.DriveInfo drive in drive_list) {
							if (path.Contains (drive.Name)) {
								drive_target = drive;
								if (drive.Name != "/")
									break;
							}
						}
						Console.WriteLine ("DRIVE {0} Available Space {1}", drive_target.Name, drive_target.AvailableFreeSpace);
						
						fdialog.Destroy ();
						if (drive_target.AvailableFreeSpace < mirrorSize)
						{
						lliurex.utils.Commands.run("zenity","--error --text="+Mono.Unix.Catalog.GetString("Not enough free space in device"));	
						}
						else 
						{
							if (System.IO.Directory.Exists(path+"llx1109"))
							{
								System.IO.Directory.Delete(path+"llx1109");
							}
							
							lliurex.utils.IO.CopyFiles cp = new lliurex.utils.IO.CopyFiles();
							cp.copyDirectory(mirrorPath,path);
							
						}
					
				}
			}
			
			
//scheduler INIT
			
		private void montaTabla()
		{
			Gtk.Table.TableChild[] w1 = new Gtk.Table.TableChild[200];
			//grid = ne
			taula = new Gtk.Table(((uint)(25)), ((uint)(8)), false);
            taula.Name = "taula";
				
			for (int i=0; i<7; i++)
			{

				botonsDia[i] = new Gtk.Button();
            	botonsDia[i].CanFocus = true;
            	botonsDia[i].Name = "buttonD" + i.ToString();
            	botonsDia[i].UseUnderline = true;
            	botonsDia[i].Relief = ((Gtk.ReliefStyle)(2));	
			
				if (language.DateTimeFormat.FirstDayOfWeek==DayOfWeek.Monday)
					if (i==6) botonsDia[i].Label = language.DateTimeFormat.DayNames[6] = language.DateTimeFormat.DayNames[0];
					else botonsDia[i].Label = language.DateTimeFormat.DayNames[i+1];
				else botonsDia[i].Label = language.DateTimeFormat.DayNames[i];
				
				botonsDia[i].Pressed += new System.EventHandler(BottonPressed);
				//---------------------
            	taula.Add(botonsDia[i]);
				w1[i+1] = ((Gtk.Table.TableChild)(taula[botonsDia[i]]));
				w1[i+1].TopAttach = ((uint) (i+2));
				w1[i+1].BottomAttach = ((uint) (i+3));
				w1[i+1].XOptions = ((Gtk.AttachOptions)(0));
    	        w1[i+1].YOptions = ((Gtk.AttachOptions)(0));
			}
			
			for (int i=0; i<24; i++)
			{
				lblBotoHora[i] =new Gtk.Label();
				lblBotoHora[i].Angle=90;
				lblBotoHora[i].LabelProp= String.Format((i).ToString()+":00","HH:MM");
				botonsHora[i] = new Gtk.Button();
				botonsHora[i].BorderWidth=0;
				botonsHora[i].Add(lblBotoHora[i]);
            	botonsHora[i].CanFocus = true;
            	botonsHora[i].Name = "buttonH" + i.ToString();
            	botonsHora[i].UseUnderline = true;
            	botonsHora[i].Relief = ((Gtk.ReliefStyle)(2));	
				botonsHora[i].Label = null;
				botonsHora[i].Pressed += new System.EventHandler(BottonPressed);
				//---------------------
            	taula.Add(botonsHora[i]);
				w1[i+8] = ((Gtk.Table.TableChild)(taula[botonsHora[i]]));
				w1[i+8].TopAttach = ((uint) (1));
				w1[i+8].BottomAttach = ((uint) (2));
				w1[i+8].LeftAttach = ((uint) (i+1));
				w1[i+8].RightAttach = ((uint) (i+2));
	            w1[i+8].XOptions = ((Gtk.AttachOptions)(0));
    	        w1[i+8].YOptions = ((Gtk.AttachOptions)(0));
			}
			
			int n = 0;
			for (int i=0; i<7; i++)
			{	
				listDia[i] = new List<Gtk.CheckButton>();
				for (int j=0; j<24; j++)
				{
					if (i==0) listHora[j] = new List<Gtk.CheckButton>();
            		chkProg[n] = new Gtk.CheckButton();
            		chkProg[n].CanFocus = true;
            		chkProg[n].Name = "checkbutton1";
            		chkProg[n].DrawIndicator = true;
            		chkProg[n].UseUnderline = true;
            		taula.Add(chkProg[n]);
            		w1[n+32] =  ((Gtk.Table.TableChild)(this.taula[chkProg[n]]));
					w1[n+32].TopAttach = ((uint) (i+2));
					w1[n+32].BottomAttach = ((uint) (i+3));
					w1[n+32].LeftAttach = ((uint) (j+1));
					w1[n+32].RightAttach = ((uint) (j+2));
	            	w1[n+32].XOptions = ((Gtk.AttachOptions)(0));
    	        	w1[n+32].YOptions = ((Gtk.AttachOptions)(0));
					listDia[i].Add (chkProg[n]);
					listHora[j].Add (chkProg[n]);
					n++;
				}
			}

			cont1.Add(taula);
            Gtk.Box.BoxChild w2 = ((Gtk.Box.BoxChild)(cont1[taula]));
            w2.Position = 1;
			
			ReadConfigData(); //load stored data
		
			
			
			if ((this.Child != null)) 
                this.Child.ShowAll();
		}
		
				
		private void ChkOps(int max, List<Gtk.CheckButton> lista)
		{
			Boolean found = false;
			int i=0;

			while (!found && i< max)
				if (lista[i].Active == false) 
					found = true;
				else i++;
			
			for (i=0;i<max;i++) 
				lista[i].Active = found;
		}
		
		private void CleanOps()
		{
			for (int i=0;i<MAX_CHKS;i++) 
				chkProg[i].Active=false;	
		}
		
		private int ActiveOps()
		{
			int n=0;
			for (int i=0;i<MAX_CHKS;i++) 
				if (chkProg[i].Active==false) n++;	
			return n;
		}
		
		private string ReadData()
		{
			System.Text.StringBuilder sb = new System.Text.StringBuilder("");
			
			for (int i=0;i<MAX_CHKS;i++) 
				if (chkProg[i].Active)
					sb.Append("1");
				else
					sb.Append("0");
			
			return sb.ToString();
		}
		
		private void RestoreData(string data)
		{
			for (int i=0;i<MAX_CHKS;i++) 
				if (data[i].Equals('0'))
					chkProg[i].Active=false;
				else
					chkProg[i].Active=true;
		}
		
		private void generateCron()
		{
			//filename with cron data usually "/etc/cron.d/sheduler"
			string fileName = "/etc/cron.d/lliurex-mirror-sheduler";
				
			
			Random random=new Random();
			int day,minute =random.Next(60);
			
			try	{
				File.Delete(fileName);
			}
			catch{}
			
			try	{
					
				// Get action for non-interactive upgrade 
				string mirrorScriptNonInteractiveArgument = SCRIPT_NON_INTERACTIVE_UPDATE;
				if (checkbutton_upgradeServer.Active){	
						mirrorScriptNonInteractiveArgument = SCRIPT_NON_INTERACTIVE_UPGRADE;
					}
					
				// Create file for cron		
				StreamWriter writer = File.AppendText(fileName);
				writer.WriteLine("SHELL=/bin/bash");
				writer.WriteLine("PATH=/usr/local/sbin:/usr/local/bin:/sbin:/bin:/usr/sbin:/usr/bin");
				
				System.Text.StringBuilder hours = new System.Text.StringBuilder("");
				Boolean found= false;
				int count=0;
				
				for (int i=0; i<7;i++)
				{
					for (int j=0; j<24;j++)
					{
						if (chkProg[i*24+j].Active)
						{
							hours.Append((j).ToString()+',');
							found=true;
							count++;
						}
					}
					if (found)
					{
						found = false;
						if (count == 24)
						{
							hours.Remove(0,hours.Length);
							hours.Append('*');
						}
						else
							hours[hours.Length-1]=' ';

						day=i;
						if (language.DateTimeFormat.FirstDayOfWeek==DayOfWeek.Monday)
						{
							if (day==6)	
								day=0;
							else
								day++;
						}
							
						System.Console.WriteLine(minute.ToString()+"	"+hours.ToString()+"	*"+" * "+day.ToString()+"	root "+mirrorScritpNonInteractive+mirrorScriptNonInteractiveArgument+" > /dev/null");
						writer.WriteLine(minute.ToString()+" "+hours.ToString()+" *"+" * "+day.ToString()+" root "+mirrorScritpNonInteractive+mirrorScriptNonInteractiveArgument+" > /dev/null");
						hours.Remove(0,hours.Length);
						count =0;
					}
				}
				writer.Close();
			}
			catch{
				Console.WriteLine("Error");
			}
		}
		
		private void ReadConfigData()
		{
			try{
				RestoreData(configFile.AppSettings.Settings["Sheduler"].Value.ToString());
			}
			catch{
				progressbar3.Text = Mono.Unix.Catalog.GetString("No tiene ninguna configuración almacenada");
			}
		}
		
		private void SaveConfigData()
		{
 			configFile.AppSettings.Settings.Add("Sheduler",  ReadData());
			configFile.Save();
			generateCron();
		}
		
		protected virtual void OnBtAleatoriPressed (object sender, System.EventArgs e)
		{
			int n,i = (int) selQty.Value;

			if (i>ActiveOps()) 
				ms.show(Mono.Unix.Catalog.GetString("No hay suficiente disponibilidad de horas"));
			else
			{
				Random random=new Random();
				while (i>0)
				{
					n= random.Next(MAX_CHKS);
					if (chkProg[n].Active == false) 
					{
						chkProg[n].Active = true;
						i--;
					}
				}
			}
		}
		
		protected virtual void OnBtCleanPressed (object sender, System.EventArgs e)
		{
				CleanOps();
		}
		
		protected virtual void OnBtApplyPressed (object sender, System.EventArgs e)
		{
			SaveConfigData();
		}

		protected virtual void OnBtRestorePressed (object sender, System.EventArgs e)
		{
			ReadConfigData();
		}
		
		protected virtual void BottonPressed (object sender, System.EventArgs e)
		{
			int i = Array.IndexOf(botonsDia, (Gtk.Button) sender);

			if (i == -1)
				ChkOps(7,listHora[Array.IndexOf(botonsHora, (Gtk.Button) sender)]);	
			else 
				ChkOps(24,listDia[i]);
		}			
			
		protected virtual void OnNotebookSwitchPage (object o, Gtk.SwitchPageArgs args)
		{
			if( notebook.CurrentPage == 0)
				this.Resize(Page1Width,Page1Heigth);
			else
				this.Resize(Page2Width,Page2Heigth);
		}
		//scheduler	END
		}
	}
}